#!/bin/bash

# If this program and HQPlayer run on different computers,
# replace localhost with IP address of computer where HQPlayer runs,
# enclosed in quotes.
# No space permitted anywhere.

hqpIP='10.0.4.5'


# Do not edit the code below unless you know what you're doing:

# export sourceN_env='4'

base_dir="/usr/local/hqp_liquidsoap/"
config_dir="${base_dir}config/"
log_dir="${base_dir}log/"

log_liquid_env="${log_dir}liquidsoap.log"
export log_liquid_env  # create environment var for liquidsoap to read

sourceN_data_file="${config_dir}sourceN_data.txt"
read sourceN_env source_name < $sourceN_data_file
export sourceN_env  # create environment var for liquidsoap to read

killall liquidsoap
killall icecast
killall pulseaudio


/usr/local/bin/icecast -c ${config_dir}icecast_config_HQP.xml >${log_dir}icecast_console.log 2>&1 &


# Do not append &.  That would run pulseaudio as 
# system daemon, not user daemon,
# causing it to refuse connection request from liquidsoap:

/usr/local/bin/pulseaudio >${log_dir}pulseaudio_console.log 2>&1


# 2019-01-15  Sum sine to keep icecast alive:
# I tried "amplify" function to further attenuate sine,
# but gain less than 1.0 disconnected icecast.
# 0.5 caused intermittent disconnection.
#
# Would it help to unify sine & pulseaudio clocks??

liquidsoap 'N=getenv("sourceN_env")' 'log_path=getenv("log_liquid_env")' 'set("log.level",4)' 'set("log.file.path",log_path)' 'set("log.file",true)' 'output.icecast(password="hackme", mount="mystream", format="audio/ogg",  %ogg(%flac(samplerate=44100, bits_per_sample=16, compression=5)), add([input.pulseaudio(device=N), sine(1., amplitude=.0001)], normalize=false))' >/dev/null 2>&1 &


# tell HQP to play:
python3 ${config_dir}HQP_start_streaming.py
